<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
      [solidifyFocusFirstElement]="true"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.archiveTypes"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>
    <ng-template [ngIf]="getFormControl(formDefinition.isMasterType)?.value"
                 [ngIfElse]="isChildType"
    >

      <mat-form-field *ngIf="getFormControl(formDefinition.typeName) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.nameLabel | translate }}</mat-label>
        <mat-select [formControl]="fd"
                    [required]="formValidationHelper.hasRequiredField(fd)"
                    [solidifyValidation]="errors"
        >
          <mat-option *ngFor="let typeName of listMasterTypesName"
                      [value]="typeName"
                      solidifyTooltipOnEllipsis
          >
            {{typeName}}
          </mat-option>
        </mat-select>
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>

    </ng-template>
    <ng-template #isChildType>
      <mat-form-field *ngIf="getFormControl(formDefinition.masterTypeId) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.masterType | translate }}</mat-label>
        <mat-select [formControl]="fd"
                    [required]="formValidationHelper.hasRequiredField(fd)"
                    [solidifyValidation]="errors"
        >
          <mat-option *ngFor="let archiveType of listMasterTypes"
                      [value]="archiveType.resId"
                      solidifyTooltipOnEllipsis
          >
            {{archiveType.typeName}}
          </mat-option>
        </mat-select>
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>

      <mat-form-field *ngIf="getFormControl(formDefinition.typeName) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.nameLabel | translate }}</mat-label>
        <input [formControl]="fd"
               [required]="formValidationHelper.hasRequiredField(fd)"
               [solidifyValidation]="errors"
               autofocus
               matInput
               tabindex="0"
        >
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>

    </ng-template>
  </ng-template>

  <ng-template #rightTemplate>
    <mat-checkbox *ngIf="getFormControl(formDefinition.isMasterType) as fd"
                  [formControl]="fd"
                  color="primary"
                  class="provide-checksums"
    >
      {{labelTranslateEnum.isMasterType | translate}}
    </mat-checkbox>
  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
